#!/bin/bash
#
# Copyright:
# ----------------------------------------------------------------------------
# This confidential and proprietary software may be used only as authorized
# by a licensing agreement from ARM Limited.
#      (C) COPYRIGHT 2018 ARM Limited, ALL RIGHTS RESERVED
# The entire notice above must be reproduced on all authorized copies and
# copies may only be made to the extent permitted by a licensing agreement
# from ARM Limited.
# ----------------------------------------------------------------------------
set -e

# Example usage
# ./bob_graph -graph_out=libmali -graph_who_uses=libmali,libLLVM -graph_dependencies=libmali,libLLVM
#
# To view dependencies of libLLVM
# ./bob_graph -graph_out=libLLVM_deps -graph_dependencies=libLLVM

# Switch to the build directory
cd "$(dirname "${BASH_SOURCE[0]}")"

# Read settings written by bootstrap.bash
BOOTSTRAP=".bob.bootstrap"
source "${BOOTSTRAP}"

# Switch to the working directory
cd "${WORKDIR}"

BOB_BUILDER="${BUILDDIR}/.bootstrap/bin/bob"

if [ ! -f "${BOB_BUILDER}" ]; then
	echo "Please first run buildme"
	echo "Missing bob_builder: ${BOB_BUILDER}"
	exit 1
fi

echo "
#
# Legend description
#
# Nodes
# green node            - static library
# orange node           - shared library
# gray node             - binary
# yellow node           - default

# Marked node
# double circle         - marked node

# Edges
# orange edges          - content of shared_libs
# orange-dashed edges   - content of export_shared_libs
# green edges           - content of static_libs
# green-dashed edges    - content of export_static_libs
# red edges             - content of whole_static
# yellow edges          - content of defaults
#
"

"${BOB_BUILDER}" -l "${BLUEPRINT_LIST_FILE}" -b "${BUILDDIR}" "$@" "${TOPNAME}"
