/*
 * Copyright:
 * ----------------------------------------------------------------------------
 * This confidential and proprietary software may be used only as authorized
 * by a licensing agreement from ARM Limited.
 *      (C) COPYRIGHT 2016-2018 ARM Limited, ALL RIGHTS RESERVED
 * The entire notice above must be reproduced on all authorized copies and
 * copies may only be made to the extent permitted by a licensing agreement
 * from ARM Limited.
 * ----------------------------------------------------------------------------
 */

package main

import (
	"flag"
	"os"
	"runtime/pprof"

	"bob/core"
)

func main() {
	// The primary builder should use the global flag set because the
	// bootstrap package registers its own flags there.
	flag.Parse()

	cpuprofile, present := os.LookupEnv("BOB_CPUPROFILE")
	if present && cpuprofile != "" {
		f, err := os.Create(cpuprofile)
		if err != nil {
			panic(err)
		}
		pprof.StartCPUProfile(f)
		defer pprof.StopCPUProfile()
	}

	core.Main()
}
