#!/bin/python

"""
 * Copyright:
 * ----------------------------------------------------------------------------
 * This confidential and proprietary software may be used only as authorized
 * by a licensing agreement from ARM Limited.
 *      (C) COPYRIGHT 2018 ARM Limited, ALL RIGHTS RESERVED
 * The entire notice above must be reproduced on all authorized copies and
 * copies may only be made to the extent permitted by a licensing agreement
 * from ARM Limited.
 * ----------------------------------------------------------------------------
"""

import argparse
import os

parser = argparse.ArgumentParser(description='Test generator.')
parser.add_argument('--in', dest='input', action='store', help='Input files')
parser.add_argument('--out', dest='output', action='store', help='Output file')

args = parser.parse_args()

if len(args.input) < 1 or len(args.output) < 1:
    print("Invalid input/output")
    print("Input: " + args.input)
    print("Output: " + args.output)
    exit(1)

input_basename = os.path.basename(args.input)
if os.path.splitext(input_basename)[1] != ".in":
    print("Input file should end with '.in': " + input_basename)
    exit(1)

output_base_name = os.path.basename(args.output)

if os.path.splitext(input_basename)[0] != os.path.splitext(output_base_name)[0]:
    print("Not matching base name: ")
    print("Input: ")
    print(os.path.splitext(input_basename))
    print("Output: ")
    print(os.path.splitext(output_base_name))
    exit(1)

if os.path.splitext(output_base_name)[1] != ".cpp":
    print("Output file should end with '.cpp': " + output_base_name)
    exit(1)

without_extension = os.path.splitext(output_base_name)[0]
with open(args.output, 'w') as outfile:
    print("Output: " + without_extension)
    outfile.write("void output_%s(){}\n" % without_extension)
