#!/usr/bin/env bash
#
# Copyright:
# ----------------------------------------------------------------------------
# This confidential and proprietary software may be used only as authorized
# by a licensing agreement from ARM Limited.
#      (C) COPYRIGHT 2016-2018 ARM Limited, ALL RIGHTS RESERVED
# The entire notice above must be reproduced on all authorized copies and
# copies may only be made to the extent permitted by a licensing agreement
# from ARM Limited.
# ----------------------------------------------------------------------------

# This script sets up the environment to be able to bootstrap the
# driver using Android paths only.

# This script should be called in the following way:
# $PATH_TO_DDK/bldsys/bootstrap_android_make.bash $PATH_TO_DDK $BUILDDIR
set -e

PATH_TO_DDK="$1"
BUILDDIR="$(readlink -m "$2")"

cd "${PATH_TO_DDK}"

# The following would setup to use Androids prebuilt go. We don't do
# this because we depend on Go 1.8 but still run on Android N (which
# has an older version).
#export GOPATH="${ANDROID_BUILD_TOP}"
#export GOROOT="${GOPATH}/prebuilts/go/linux-x86"
#export PATH="${GOROOT}/bin:$PATH"

# Bootstrap Bob. Always use absolute SRCDIR
export BUILDDIR
export SRCDIR="$(readlink -f ${PATH_TO_DDK})"
export TOPNAME="build.bp"
export BLUEPRINT_LIST_FILE="${BUILDDIR}/.bplist"
export CONFIGNAME="mali.config"
export BOB_CONFIG_OPTS="--ignore-missing"
export BOB_CONFIG_PLUGINS="bldsys/tools/kernel_explore bldsys/tools/tools_checker_plugin bldsys/tools/ddk_host_explore"
bldsys/bob/bootstrap_androidmk.bash > /dev/null

# Pick up some info that bob has worked out
BOOTSTRAP=".bob.bootstrap"
source "${BUILDDIR}/${BOOTSTRAP}"

# Setup the DDK build script
ln -sf "${SRCDIR}/bldsys/buildme.bash" "${BUILDDIR}/buildme"
